<script lang="ts">
import Vue from 'vue';
import GitLabDuoWorkflowFormWrapper from './gitlab-duo-workflow-form-wrapper.vue';
// Note that GitLabDuoWorkflowFormWrapper will default to isDark = true in this component, so if this is used in other new pages, we will need to account for that
import FormTabs from './form-tabs.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'GitlabDuoWorkflowContent',
  components: { FormTabs, GitLabDuoWorkflowFormWrapper },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      default: null,
    },
    form: {
      type: Object,
      required: false,
      default: null,
    },
    formTabs: {
      type: Object,
      required: false,
      default: () => {},
    },
    disclaimer: {
      type: String,
      required: false,
    },
    param: {
      type: String,
      required: false,
      default: null,
    },
    cards: {
      type: Array,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    onFormSubmit() {
      this.$emit('submit');
    },
  },
});
</script>

<template>
  <section class="gitlab-duo-workflow-content">
    <SlpContainer class="gitlab-duo-workflow-content__container">
      <SlpRow class="gitlab-duo-workflow-content__row">
        <SlpColumn :cols="6">
          <div class="gitlab-duo-workflow-content__wrapper">
            <div v-if="data" class="gitlab-duo-workflow-content__text-block">
              <SlpTypography
                v-if="data?.header"
                tag="h5"
                variant="heading5"
                class="slp-mb-8 slp-mt-16"
              >
                {{ data?.header }}
              </SlpTypography>

              <div
                v-if="data?.text"
                class="gitlab-duo-workflow-content__text"
                v-html="$md.render(data?.text)"
              ></div>
            </div>
            <div v-for="card in cards" :key="card?.title">
              <div class="gitlab-duo-workflow-content__text-block">
                <lite-vimeo
                  v-if="card?.video"
                  :videoid="getVimeoVideoId(createVideoSource(card.video))"
                  class="slp-mb-32"
                />
                <SlpTypography
                  v-if="card?.title"
                  tag="h5"
                  variant="heading5-bold"
                  class="slp-mb-24 gitlab-duo-workflow-content__card-heading"
                >
                  {{ card?.title }}
                </SlpTypography>
                <SlpTypography
                  v-if="card?.subtitle"
                  tag="h5"
                  variant="body1-bold"
                  class="slp-mb-8 slp-mt-16"
                >
                  {{ card?.subtitle }}
                </SlpTypography>
                <div
                  v-if="card?.description"
                  class="gitlab-duo-workflow-content__text"
                  v-html="$md.render(card?.description)"
                ></div>
                <SlpButton
                  v-if="card.button?.fields"
                  :href="card.button?.fields?.externalUrl"
                  variant="tertiary"
                  :data-ga-name="card.button?.fields?.data_ga_name"
                  :data-ga-location="card.button?.fields?.data_ga_location"
                  class="slp-mr-24 gitlab-duo-workflow-content__button"
                >
                  {{ card.button?.fields?.text }}
                  <SlpIcon variant="product" name="chevron-lg-right" />
                </SlpButton>
              </div>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="6">
          <FormTabs
            v-if="formTabs"
            :data="formTabs"
            :param="param"
            @submit="onFormSubmit"
          />
          <GitLabDuoWorkflowFormWrapper
            v-if="!formTabs && form"
            id="form"
            data-aos="fade-up"
            data-aos-duration="750"
            :data="form"
            :is-dark="true"
            @submit="onFormSubmit"
          />
        </SlpColumn>
      </SlpRow>
      <SlpTypography tag="p" variant="body3" class="disclaimer">{{
        disclaimer
      }}</SlpTypography>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.gitlab-duo-workflow-content {
  color: $color-text-50;
  padding-top: $spacing-64;
  background: $color-surface-700;

  &__wrapper {
    @media (min-width: $breakpoint-md) {
      padding-right: 124px;
    }
  }
  &__container {
    padding-bottom: 4px;
  }
  &__button {
    background-color: transparent;
    color: $color-primary-200;
    text-align: center;
    justify-content: center;
    width: auto;
    &:hover,
    &:focus {
      color: $color-primary-300;
      background: $color-primary-200;
    }
  }
  :deep {
    .slp-col-md-6 {
      width: 100%;
    }
  }
  &__list {
    padding: $spacing-24;
    @media (min-width: $breakpoint-md) {
      padding: 0;
    }
  }
  &__note {
    color: $color-surface-500;
    margin-top: auto;
    font-style: italic;
  }
  &__text-block {
    padding: 24px;
    margin-bottom: 24px;
    @media (min-width: $breakpoint-md) {
      padding: 0;
    }
  }
  &__text {
    &:deep(h5) {
      font-size: 1.5rem;
      line-height: 1.1666666667;
      font-weight: 580;
      letter-spacing: -0.02em;
      padding-bottom: 0.25em;
    }

    &:deep(p) {
      margin: 24px 0 8px 0;
      strong {
        font-weight: 600;
        color: $color-text-50;
      }
      &:first-of-type {
        margin-top: 0;
      }
    }
    &:deep(a) {
      color: $color-accent-400;
    }

    &:deep .disclaimer {
      color: $color-surface-400;
      font-size: 14px;
      font-style: italic;
    }
    &:deep(p) {
      color: $color-text-100;
    }
    &:deep(ul) {
      padding-left: 32px;
      margin: 16px 0;

      li {
        margin-top: 12px;
        position: relative;
        color: $color-text-100;

        &:before {
          content: url('/nuxt-images/icons/list-check-dark.svg');
          position: absolute;
          top: 3px;
          left: -30px;
        }
      }
    }
    &:deep(em) {
      font-size: 14px;
      color: $color-text-50;
    }
    &:deep {
      > :last-child {
        margin-top: 0;
      }
    }
  }
  &__card-heading {
    border-top: 1px solid $color-surface-600;
    padding-top: 24px;
  }
  &__button {
    color: $color-text-50;
  }

  .disclaimer {
    padding: 64px 0;
    color: $color-surface-400;
  }
}
</style>
